unit kuIconize;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Dialogs,
  ComCtrls, IniFiles, ShellAPI, Registry, ShlObj, Forms,

  kuModul,
  kuShell,
  kuY;


//Iconize
function  Iconize_Folder(const Dir, IcoPath, icoIndex: string; CopyIcoInFolder: Boolean; iniOldVer: Boolean = True): Boolean;
procedure Iconize_FileType(Ext, icoPath: string; icoIndex: integer = -1);
procedure Iconize_Drive(const BukvaDiska, icoPath: string; icoIndex: integer = -1);
function  Iconize_Element(const Element, icoPath, icoIndex: string; CopyIco: Boolean): Boolean;


//Deiconize
procedure Deiconize_Folder(const Dir: string; DeleteIco: Boolean = True);
procedure Deiconize_Drive(const BukvaDiska: string);
function  Deiconize_Element(const Element: string; DeleteIco: Boolean = True): Boolean;
procedure Deiconize_FileType(Ext: string);


//Get ico from elm
function GetIco_Disk(const Bukva: string; var icoPath_: string; var icoIndex_: integer): Boolean;
function GetIco_File  (const ext: string; var icoPath_: string; var icoIndex_: integer): Boolean;
function GetIco_Folder(const Dir: string; var icoPath_: string; var icoIndex_: integer): Boolean;
function GetIco_Elm(const inPath: string; var icoPath_: string; var icoIndex_: integer): Boolean;


//Shell ico
function  Shell_ico(const ext: string; icoSmall: Boolean): TIcon;
function  Shell_ico_Index(FullPath: string) : integer;
procedure Shell_ico_LoadAll(MyImageList: TImageList; icoSmall: Boolean);
procedure Shell_ico_Refresh;
function  Shell_ico_GetAssociated(const AExtension: string; ASmall: Boolean): HIcon;


//Aver
function DllicoToList(const DllPath: string; IL16, IL32: TImageList): Boolean;
//function IsIcoLib(Path: string): Boolean;


var
_Elm_DirNotExist_OnIconize : string = ',    ,  !';
_Elm_DirNotExist_OnClear   : string = ',     ,  !';
_Ico_NotExist              : string = ',     -  !';




implementation


{$REGION ' help:   ico   '}
{

 ,  Windows      ,    Defaultlcon,    IconHandler,    ,        .
IconHandler -  ,    ,    . , Adobe Acrobat   ,       .pdf.   .pdf IconHandler  Acrobat         :

HKEY_CLASSES_ROOT\. pdf \ShellEx\IconHandler
HKEY_CLASSES_ROOT\.pdf\ShellEx\(BB2E617C - e920 - llDl - 9A0B - 00C04FC2D6Cl
HKEY_CLASSES_ROOT\AcroExch. Document. 7\ShellEx\IconHandler
HKEY CLASSES_ROOT\AcroExch.Document.7\ShellEx \
HKEY_CLASSES_ROOT\SystemFileAssociations\. pdf\ShellEx\IconHandler HKEY
CLASSES_ROOT\SystemFileAssociations\.pdf\ShellEx\
HKEY_CLASSESROOT\SystemFileAssociations\image\ShellEx\IconHandler HKEY_
CLASSES_ROOT\SystemFileAssociations\image\ShellEx\
,  Adobe     ,    IconHandler.      38-  ID,      HKEY_CLASSES_ROOT\CLSID,      .dll.
   IconHandler        IconHandler,     .dll-     .        IconHandler   .
    ?    IconHandler    IconHandler     IconHandler      ,    Defaultlcon.
 ,      ,       ?   ,    IconHandler,    ,     -  Windows,  , ,    ,        :
1.   .
2.       ,    . ,          TIFF,   HKEY_CLASSES_ROOT\. tif.
3.   .tif  PerceivedType.    ,         PerceivedType.
4.    PerceivedType,  image   .
5.    HKEY_CLASSES_ROOT\SystemFileAssociations\image.         ,   jpg, .bmp  .tif
6.   ShellEx   , .    ,         .
7.       .    .
8.      ;   ,  
 ,  Windows.  ,  IconHandlers          ,         ,        .
}
{$ENDREGION}




{$REGION          '   Iconize   '}




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Folder
function Iconize_Folder(const Dir, IcoPath, icoIndex: string; CopyIcoInFolder: Boolean; iniOldVer: Boolean = True): Boolean;
{   
Dir -   
IcoPath -    
CopyIcoInFolder -    ?
icoIndex -  
iniOldVer -  ini    

    :
1)    
2)   :   
3)     Desktop.ini
4)   Desktop.ini: 
5)   Desktop.ini :
[.ShellClassInfo]
IconResource=.ico,0

IconFile=.ico
IconIndex=0
}
var
  strs: TStrings;
  iniPath, icoName, icoNewPath, t: string;


begin
Result := False;


if not DirectoryExists(ExcludeTrailingBackslash(Dir))
then
begin
  yy(_Elm_DirNotExist_OnIconize +#13#10+ Dir, 'Iconize_Folder_Set');
  exit;
end;


if not FileExists(IcoPath)
then
begin
  yy(_Ico_NotExist +#13#10+ IcoPath, 'Iconize_Folder_Set');
  exit;
end;



iniPath    := IncludeTrailingBackslash(Dir) + 'Desktop.ini';
icoName    := ExtractFileName(IcoPath); //   
icoNewPath := IncludeTrailingBackslash(Dir) + icoName; //   



//   ,   
if FileExists(iniPath) then Deiconize_Folder(Dir, True);






{$REGION '   (1)    '}

// :  
SetFileAttributes(PChar(Dir), FILE_ATTRIBUTE_NORMAL);
SetFileAttributes(PChar(Dir), FILE_ATTRIBUTE_READONLY);
//SetFileAttributes(PChar(Dir), FILE_ATTRIBUTE_ARCHIVE);

{$ENDREGION}




{$REGION '   (2) Desktop.ini   '}


strs := TStringList.Create;
strs.Append('[.ShellClassInfo]');

if CopyIcoInFolder
then t := icoName
else t := icoPath;

if ExtractFilePath(icoPath) = ExtractFilePath(iniPath)
then t := icoName;

if iniOldVer
then
begin
    strs.Append('IconFile=' + t);
    strs.Append('IconIndex=' + icoIndex);
end

else strs.Append('IconResource=' + t +','+ icoIndex);

//strs.Append('ConfirmFileOp=0');

strs.SaveToFile(iniPath);

// Desktop.ini:  + 
//SetFileAttributes(PChar(iniPath), FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_HIDDEN);
SetFileAttributes(PChar(iniPath), FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_HIDDEN + FILE_ATTRIBUTE_SYSTEM);


{$ENDREGION}




{$REGION '   (3) ico   '}


if CopyIcoInFolder
then
begin
//    yy('CopyIcoInFolder');

    //   
    CopyFile(PChar(IcoPath), PChar(icoNewPath), False);

    //  :  + 
    SetFileAttributes(PChar(icoNewPath), FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_HIDDEN);
end;


{$ENDREGION}



Result := True;



//  :
SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
//yy(Dir_Up(Dir, t));
t := 'C';
SHChangeNotify(SHCNE_UPDATEDIR,  SHCNF_PATH OR SHCNF_FLUSH,pchar(t), nil);
SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_PATHA,pchar(t), nil);
SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_PRINTERA,pchar(t), nil);
SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_DWORD,pchar(t), nil);
SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_PATHW,pchar(t), nil);
SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_PRINTERW,pchar(t), nil);
SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_TYPE,pchar(t), nil);

SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);

{
FILE_ATTRIBUTE_COMPRESSED   
FILE_ATTRIBUTE_DIRECTORY     

FILE_ATTRIBUTE_ARCHIVE      
FILE_ATTRIBUTE_HIDDEN       
FILE_ATTRIBUTE_READONLY       
FILE_ATTRIBUTE_SYSTEM        

FILE_ATTRIBUTE_NORMAL        (    )
}
end;




//------------------------------------------------------------------------------ Drive
procedure Iconize_Drive(const BukvaDiska, icoPath: string; icoIndex: integer = -1);
var
  Reg: TRegistry;
  icoString: string;

begin

if icoIndex = -1
then icoString := icoPath
else icoString := icoPath + ',' + inttostr(icoIndex);

Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;

Reg.OpenKey('\Applications\Explorer.exe\Drives\' + BukvaDiska + '\DefaultIcon', true);
Reg.WriteString('', icoString);
Reg.CloseKey;

//Reg.OpenKey('\Applications\Explorer.exe\Drives\' + BukvaDiska + '\preZELO', true);
//Reg.WriteString('', icoString);
//Reg.CloseKey;

Reg.Free;

//  :
SHChangeNotify(SHCNE_UPDATEDIR,  SHCNF_PATH OR SHCNF_FLUSH, pchar(BukvaDiska + ':\'), nil);
//SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);

end;




//------------------------------------------------------------------------------ File Type
procedure Iconize_FileType(Ext, icoPath: string; icoIndex: integer = -1);
var
  Reg: TRegistry;
  icoString, Key, Pere: string;



    procedure RegAddIconize(extkey, icoString: string);
    begin
      if Reg.OpenKey(extkey + '\DefaultIcon', true)
      then Reg.WriteString('', icoString);
      Reg.CloseKey;

//      //  
//      if Reg.OpenKey(extkey + '\shellex\IconHandler', false)
//      then Reg.DeleteValue('');
//      Reg.CloseKey;
    end;




begin

if Ext[1] = '.' then Ext := copy(Ext, 2, length(Ext));

if Ext = 'lnk' then exit;
if Ext = 'exe' then exit;
if Ext = 'ico' then icoString := '%1';

if icoIndex = -1
then icoString := icoPath
else icoString := icoPath + ',' + inttostr(icoIndex);

Reg := TRegistry.Create;




{$REGION ' .ext   '}

Reg.RootKey := HKEY_CLASSES_ROOT;

Key := '.' + Ext;

Reg.OpenKey(Key, true);
Pere := Reg.ReadString(''); //   ()
if Pere = ''
then
begin
  Pere := ext + 'file';
  Reg.WriteString('', Pere);// 
end;
Reg.CloseKey;
RegAddIconize(Key, icoString);//  .ext

//Reg.OpenKey(Pere, true);//  -    ,   :
if not reg.KeyExists(Pere)
then
begin
    Reg.CreateKey(Pere);
end;

RegAddIconize(Pere, icoString); //  Pere
  
  
{$ENDREGION}





{$REGION ' CURRENT_USER Progid '}
  
  
Reg.RootKey := HKEY_CURRENT_USER;
Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext +'\UserChoice';
if Reg.KeyExists(Key)
then
begin
  
  Reg.OpenKeyReadOnly(Key); //   !!! :(

  if Reg.ValueExists('Progid')
  then
  begin
        Key := Reg.ReadString('Progid');
        Reg.CloseKey;


//        Reg.Free;                // ,    DefaultIcon

//        Reg := TRegistry.Create;
//        Reg.RootKey := HKEY_CLASSES_ROOT;



//        Reg.DeleteKey(regNOD + '\DefaultIcon');
//        Reg.CreateKey(regNOD + '\DefaultIcon');
  
//        if Reg.KeyExists  (Key + '\DefaultIcon')
//        then if reg.DeleteKey(Key + '\DefaultIcon') then yy('deleted!!!!');
//          yy(Key+'copy');
//        Reg.MoveKey(Key, Key+'copy', false);
//        Reg.OpenKey(Key+'copy\DefaultIcon', true);
        // then yy('opened + ' + icoString);
  
//        reg.MoveKey(Key, Key + '.copy', false);


        RegAddIconize(key, icoString);
  end;
  
end;
Reg.CloseKey;

  
{$ENDREGION}






Reg.Free;  

//  :
SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
//Shell_ico_Refresh;

end;




//------------------------------------------------------------------------------ Element
function Iconize_Element(const Element, icoPath, icoIndex: string; CopyIco: Boolean): Boolean;
begin




{$REGION '    .ext '}
if (Element[1] = '.') and (pos('\', Element) = 0)
then
begin
//        yy('  : '+az+ iFullPath +az+ ': '+az+ icoPath);
    Iconize_FileType( copy(Element, 2, Length(Element)), icoPath, strtoint(icoIndex) );
    Result := True;
end;
{$ENDREGION}





{$REGION '   C: '}
  if (ExtractFileDrive(Element) = Element) or ((ExtractFileDrive(Element) +'\') = Element)
  then
  begin
  //          yy(' : '+az+ iFullPath +az+ ': '+az+ icoPath);
      Iconize_Drive(Element[1], icoPath, strtoint(icoIndex));
      Result := True;
  end;
{$ENDREGION}





{$REGION '   FolderPath '}
  if DirectoryExists(Element)
  then
  begin
  //          yy(' : '+az+ iFullPath +az+ ': '+az+ icoPath);
      if Iconize_Folder(Element, icoPath, icoIndex, CopyIco)
      then
      begin
        //...  :    !!! :(
        Result := True;
      end;
  end;
{$ENDREGION}





end;





{$ENDREGION}






{$REGION '   Deiconize   '}





//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Folder
procedure Deiconize_Folder(const Dir: string; DeleteIco: Boolean = True);
//    ,  
var
ini: TiniFile;
iniPath, icoPath, icoIndex: string;
b{, icoIndex}: integer;
strs: TStrings;

begin


if not DirectoryExists(Dir)
then
begin
  ShowMessage(_Elm_DirNotExist_OnClear +#13#10+ Dir);
  exit;
end;

iniPath := IncludeTrailingBackslash(Dir) + 'Desktop.ini';


//   
SetFileAttributes(PChar(Dir), FILE_ATTRIBUTE_NORMAL);


ini := TiniFile.Create(iniPath);
strs := TStringList.Create;


if ini.ValueExists('.ShellClassInfo', 'IconResource')

then////IconResource
begin
    icoPath := ini.ReadString('.ShellClassInfo', 'IconResource', '');

    if Str_Find_Prev(',', icoPath, False, length(icoPath), b)
    then
    begin
        icoPath  := Copy( icoPath, 1, b-1);
        icoIndex := Copy( icoPath, b+1, length(icoPath) );
    end;
end


else////IconFile + IconIndex
begin
    icoPath  := ini.ReadString('.ShellClassInfo', 'IconFile',  '');
    icoIndex := ini.ReadString('.ShellClassInfo', 'IconIndex', '');
end;

SetFileAttributes(PChar(iniPath), FILE_ATTRIBUTE_NORMAL);
SetFileAttributes(PChar(iniPath), FILE_ATTRIBUTE_HIDDEN);
SetFileAttributes(PChar(iniPath), FILE_ATTRIBUTE_ARCHIVE);

ini.DeleteKey('.ShellClassInfo', 'IconResource');
ini.DeleteKey('.ShellClassInfo', 'IconFile');
ini.DeleteKey('.ShellClassInfo', 'IconIndex');
ini.DeleteKey('.ShellClassInfo', 'ConfirmFileOp');


//      strs
ini.ReadSection('.ShellClassInfo', strs);


//    ,   
if strs.Text = '' then ini.EraseSection('.ShellClassInfo');

ini.Free;

// Desktop.ini    
strs.LoadFromFile(iniPath);
if strs.Text = '' then DeleteFile(iniPath);



if DeleteIco
then
begin
    if (ExtractFileExt(icoPath) = '.ico') or (ExtractFileExt(icoPath) = '.bmp')
    then
    begin
          //  
          if ExtractFilePath(icoPath) = ''
          then DeleteFile(IncludeTrailingBackslash(Dir) + icoPath);
    end;
end;


//:  - :
//...  :    !!! :(
//SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);



end;




//------------------------------------------------------------------------------ Drive
procedure Deiconize_Drive(const BukvaDiska: string);
{
Reset Drive ico To Default
}

var
  Reg: TRegistry;
  t: string;

begin


Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;

t := '\Applications\Explorer.exe\Drives\' + BukvaDiska + '\DefaultIcon';
Reg.DeleteKey(t);
Reg.CloseKey;

//Reg.OpenKey('\Applications\Explorer.exe\Drives\' + BukvaDiska + '\preZELO', true);
//Reg.WriteString('', icoString);
//Reg.CloseKey;

Reg.Free;

//  :
SHChangeNotify(SHCNE_UPDATEDIR,  SHCNF_PATH OR SHCNF_FLUSH, pchar(BukvaDiska + ':\'), nil);
//SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);

end;




//------------------------------------------------------------------------------ FileType
procedure Deiconize_FileType(Ext: string);
var
Reg: TRegistry;
Key, Pere: string;


    procedure RegDeIconize(const extkey: string);
    begin
//      if not
      Reg.DeleteKey(extkey + '\DefaultIcon');
//      then yy('   : '+extkey + '\DefaultIcon');

//      Reg.OpenKey(extkey, False);
        //  
//      Reg.DeleteKey(extkey + '\shellex\IconHandler');
//      Reg.CloseKey;
    end;



begin

if Ext[1] = '.' then Ext := copy(Ext, 2, length(Ext));

if Ext = 'lnk' then exit;
if Ext = 'exe' then exit;
if Ext = 'ico' then exit;

Reg := TRegistry.Create;



{$REGION ' .ext   '}

Reg.RootKey := HKEY_CLASSES_ROOT;

Key := '.' + Ext;
RegDeIconize(Key); //   .ext

if Reg.KeyExists(Key)
then
begin
    Reg.OpenKey(Key, False);
    Pere := Reg.ReadString(''); //   ()
    Reg.CloseKey;

    if Pere <> ''
    then RegDeIconize(Pere); //    
end;


{$ENDREGION}




//Progid';


Reg.Free;




//  :
SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
//Shell_ico_Refresh;
end;



//------------------------------------------------------------------------------ Element
function Deiconize_Element(const Element: string; DeleteIco: Boolean = True): Boolean;
{
Element:
.ext
FolderPath
C:
}

begin



{   DRIVE   }
if (ExtractFileDrive(Element) = Element) or ((ExtractFileDrive(Element)+'\') = Element)
then
begin
    Deiconize_Drive(Element);
    Result := True;
    exit;
end;




{   FOLDER   }
if DirectoryExists(Element)
then
begin
//    if
    Deiconize_Folder(Element, DeleteIco)
//    then
//    begin
//      Result := True;
//    end;
end;





end;




{$ENDREGION}





{$REGION '   Get ico   '}


//------------------------------------------------------------------------------ Get ico Disk
function GetIco_Disk (const Bukva: string; var icoPath_: string; var icoIndex_: integer): Boolean;
var
  Reg: TRegistry;
  s: string;

begin

Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;

if Reg.OpenKey('Applications\Explorer.exe\Drives\' + Bukva + '\DefaultIcon', false)
then s := Reg.ReadString('');
Reg.CloseKey;

icoPath_  := ParamStr(0);
icoIndex_ := strtoint(ParamStr(1));

Reg.Free;

end;




//------------------------------------------------------------------------------ Get ico Folder
function GetIco_Folder(const Dir: string; var icoPath_: string; var icoIndex_: integer): Boolean;
//    Desctop.ini
var
ini: TiniFile;
iniPath, icoPath, icoIndex: string;
b: integer;

begin
Result := False;


if not DirectoryExists(Dir) then exit;

iniPath := IncludeTrailingBackslash(Dir) + 'Desktop.ini';
if not FileExists(iniPath) then exit;


ini := TiniFile.Create(iniPath);

icoPath := ini.ReadString('.ShellClassInfo', 'IconResource', '');
if icoPath <> ''
then
begin

      if Str_Find_Prev(',', icoPath, False, length(icoPath), b)
      then
      begin
          icoIndex  := Copy( icoPath, b+1, length(icoPath) );
          icoIndex_ := strtoint(icoPath);
      end;

      icoPath  := Copy( icoPath, 1, b-1);

      if FileExists(icoPath)

      then Result := True

      else
      begin
           icoPath := IncludeTrailingBackslash(Dir) + icoPath;
           if FileExists(icoPath) then Result := True;
      end;

      icoPath_  := icoPath;

//      yy(icoPath);
      exit;
end;


icoPath := ini.ReadString('.ShellClassInfo', 'IconFile', '');
if icoPath <> ''
then
begin

      if FileExists(icoPath)

      then Result := True

      else
      begin
           icoPath := IncludeTrailingBackslash(Dir) + icoPath;
           if FileExists(icoPath) then Result := True;
      end;

      icoPath_  := icoPath;





      icoIndex := ini.ReadString('.ShellClassInfo', 'IconIndex', '');
      if icoIndex = ''
      then exit
      else icoIndex_ := strtoint(icoIndex);



//      yy(icoPath);
      exit;
end;



end;




//------------------------------------------------------------------------------ Get ico FileType
function GetIco_File(const ext: string; var icoPath_: string; var icoIndex_: integer): Boolean;
//  
var
  Reg: TRegistry;
  icoString, Key, s: string;


begin
Result := false;

// yy('GetIco_FileType');


{$REGION ' CURRENT_USER Progid '}
Reg := TRegistry.Create;
Reg.RootKey := HKEY_CURRENT_USER;

key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext +'\UserChoice';


if Reg.KeyExists(key)
then
begin
    if Reg.OpenKeyReadOnly(key)
    then
    begin
        key := Reg.ReadString('Progid'); //   ()
//        yy('   (): ' + s);
        reg.CloseKey;

        if key = ''

        then
        begin
            Key := 'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.' + Ext +'\DefaultIcon';
        end

        else
        begin
//            reg.Free;
//            Reg := TRegistry.Create;
            Reg.RootKey := HKEY_CLASSES_ROOT;

            key := key + '\DefaultIcon';
        end;


        if reg.OpenKeyReadOnly(key)
        then icoString := reg.ReadString('');
        reg.CloseKey;

//        yy(key, 'key');

    end;

    if icoString <> ''
    then
    begin
        Result := true;
        GetParamStrIco(icoString, icoPath_, icoIndex_);
//        yy(icoString+#13#10+icoPath_+#13#10+inttostr(icoIndex_), 'CURRENT_USER Progid');


        Reg.CloseKey;
        Reg.Free;
        exit;
    end;
end;


Reg.Free;
{$ENDREGION}




{$REGION ' .ext '}
Reg := TRegistry.Create;
Reg.RootKey := HKEY_CLASSES_ROOT;

key := '.' + Ext;

if Reg.KeyExists(key)
then
begin
    if Reg.OpenKeyReadOnly(key)
    then
    begin
        s := Reg.ReadString(''); //   ()
//        yy('   (): ' + s);
        reg.CloseKey;

        if (s <> '') and reg.KeyExists(s)
        then key := s;

        key := key + '\DefaultIcon';



        if reg.OpenKeyReadOnly(key)
        then icoString := reg.ReadString('');
        reg.CloseKey;
    end;

    if icoString <> ''
    then
    begin
        Result := true;
        GetParamStrIco(icoString, icoPath_, icoIndex_);
//        yy(icoString+#13#10+icoPath_+#13#10+inttostr(icoIndex_), '.ext')
    end;
end;


Reg.Free;
{$ENDREGION}


end;



//------------------------------------------------------------------------------ Get ico Uni
function GetIco_Elm(const inPath: string; var icoPath_: string; var icoIndex_: integer): Boolean;
var
 s, ext, Path: string;
 Index: integer;

label
  lab_GoodEnd;


begin
Result := false;

Index := 0;
Path := inPath;
ext  := AnsiLowerCase( File_ExtOnly(Path) );


{ ico}
if ext = 'ico' then goto lab_GoodEnd;


{ }
if ext = 'lnk' then Path := Lnk_GetPath(Path);
//yy(Path);
//exit;


{ }
if DirectoryExists(Path)
then
begin
//    yy('');
    if GetIco_Folder(Path, s, Index)

    then
    begin
        Path := s;
        goto lab_GoodEnd;
    end

    else exit;
end;
//yy(Path);
//exit;



ext := AnsiLowerCase( File_ExtOnly(Path) );



if (ext = 'exe')
or (ext = 'dll')
or (ext = 'icl')
//or (ext = 'ico')

then
begin
//    yy('ico, exe, dll, icl');
    if FileExists(Path)
    then goto lab_GoodEnd
    else exit;
end

else
begin
//    yy('');
    if GetIco_File(ext, Path, Index)

    then
    begin
//    yy(Path+az+inttostr(Index), '');
//    exit;
        if FileExists(Path)
        then goto lab_GoodEnd
        else exit;
    end

    else
    begin
        icoPath_  := '';
        icoIndex_ := 0;
        exit;
    end;
end;





lab_GoodEnd:

Result := true;
icoPath_  := Path;
icoIndex_ := Index;
//yy(Path+#13#10+inttostr(Index), 'EMD');
end;





{$ENDREGION}





{$REGION '  Shell  ico   '}



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ico
function Shell_ico(const ext: string; icoSmall: Boolean): TIcon;
//    .
//ext - ()        : .zip
//   ext     ,    

var
ShInfo: TSHFileInfo;
Flags: Cardinal;

begin

if icoSmall
then Flags := SHGFI_ICON or SHGFI_SMALLICON
else Flags := SHGFI_ICON or SHGFI_LARGEICON;

SHGetFileInfo(PChar(ext), FILE_ATTRIBUTE_NORMAL, ShInfo, SizeOf(TSHFileInfo), Flags);

Result := TIcon.Create;
Result.Handle := ShInfo.hIcon;

end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ico Index
function Shell_ico_Index(FullPath: string): integer;
var ShInfo: TSHFileInfo;
begin

SHGetFileInfo( PChar(FullPath), 0, ShInfo, SizeOf(ShInfo), SHGFI_TYPENAME or SHGFI_SYSICONINDEX );
Result := ShInfo.iIcon;

end;


//------------------------------------------------------------------------------ ico Load
procedure Shell_ico_LoadAll(MyImageList: TImageList; icoSmall: Boolean);
//     
var
 SysImageList: uint;
 Flags: Cardinal;
 ShInfo: ShFileInfo;

begin

//MyImageList.Clear;

if icoSmall
then Flags := SHGFI_SYSICONINDEX or SHGFI_SMALLICON {or SHGFI_USEFILEATTRIBUTES}
else Flags := SHGFI_SYSICONINDEX or SHGFI_LARGEICON {or SHGFI_USEFILEATTRIBUTES};


// 
SysImageList := SHGetFileInfo('', 0, ShInfo, SizeOf(TSHFileInfo), Flags);


if SysImageList <> 0
then MyImageList.Handle := SysImageList;

end;


//------------------------------------------------------------------------------ ico Refresh
procedure Shell_ico_Refresh;
//   
begin
SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
end;



//------------------------------------------------------------------------------
function  Shell_ico_GetAssociated(const AExtension: string; ASmall: Boolean): HIcon;
var
Info: TSHFileInfo;
Flags: Cardinal;

begin

if ASmall
then Flags := SHGFI_ICON or SHGFI_SMALLICON or SHGFI_USEFILEATTRIBUTES
else Flags := SHGFI_ICON or SHGFI_LARGEICON or SHGFI_USEFILEATTRIBUTES;

SHGetFileInfo(PChar(AExtension), FILE_ATTRIBUTE_NORMAL, Info,
SizeOf(TSHFileInfo), Flags);
Result := Info.hIcon;

end;





{$ENDREGION}







//------------------------------------------------------------------------------ Dll ico to List
function DllicoToList(const DllPath: string; IL16, IL32: TImageList): Boolean;
var
  ic: TIcon;
  i, iccount: integer;


begin

if not FileExists(DllPath) then Exit;

//Form1.Canvas.FillRect(Form1.Canvas.ClipRect);
i := -1;
iccount := ExtractIcon( Application.Handle, PChar(DllPath), i );

IL32.Clear;

if iccount = 0 then exit;


ic := TIcon.Create;

for i := 0 to iccount - 1 do
begin
    ic.Handle := ExtractIcon(Application.Handle, PChar(DllPath), i);
    IL32.AddIcon(ic);
//    IL16.AddIcon(ic);
end;

ic.Destroy;


end;




//------------------------------------------------------------------------------ Is Ico Lib
function IsIcoLib(Path: string): Boolean;
begin

if (AnsiLowerCase(ExtractFileExt(Path)) = '.exe') or
   (AnsiLowerCase(ExtractFileExt(Path)) = '.dll') or
   (AnsiLowerCase(ExtractFileExt(Path)) = '.icl')

   then Result := true
   else Result := false;

end;


end.
