unit kuTreeView;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ComCtrls, ShellAPI,
  ImgList, ShlObj,
  kuModul,
  kuShell,
  kuY;



//TreeView
procedure TVE_LoadRoot(TV: TTreeView; MyTImageList: TImageList = nil);
procedure TVE_LoadSub(TV: TTreeView; ParentNode: TTreeNode);
function  TVE_DownTo(TV: TTreeView; Path: string; Separator: Char): TTreeNode;
procedure TVE_OneIcoRefresh(TV: TTreeView; Node: TTreeNode; icoPath : string);




implementation




{$REGION          '   TVS --- TreeView Shell   '}




procedure TVE_LoadRoot(TV: TTreeView; MyTImageList: TImageList = nil);
var
  c: char;
  s: string;
  node: TTreeNode;
  DriveType: integer;
  icoList: TImageList;

begin
TV.Items.BeginUpdate;

if MyTImageList = nil
then icoList := TImageList.Create(TV.Owner)
else icoList := MyTImageList;


TV.StateImages := icoList;
TV.Images := icoList;
Shell_ico_LoadAll(icoList, True);


for c := 'A' to 'Z'
do
begin
  s := c + ':';

  DriveType := GetDriveType(PChar(s));

  if DriveType = 1 then continue;

  if (DriveType <> DRIVE_FIXED) and (DriveType <> DRIVE_REMOVABLE) then continue;


  node := TV.Items.AddChild(nil, s);
  node.ImageIndex := Shell_ico_Index(s);
  node.SelectedIndex := node.ImageIndex;
  node.HasChildren := true;
end;
        

TV.Items.EndUpdate;
end;



procedure TVE_LoadSub(TV: TTreeView; ParentNode: TTreeNode);
var
  sr, srChild: TSearchRec;
  node: TTreeNode;
  path: string;


begin


node := ParentNode;
Node.DeleteChildren;
path := '';

repeat
  path := node.Text + '\' + path;
  node := node.Parent;
until node = nil;



if FindFirst(path + '*.*', faDirectory + faVolumeId + faHidden + faSysFile, sr) = 0
then
begin
    repeat

        if sr.Name = '.'  then Continue;
        if sr.Name = '..' then Continue;
        

        if sr.Attr and faDirectory > 0
        then
        begin

            node := TV.Items.AddChild(ParentNode, sr.name);
            node.ImageIndex := Shell_ico_Index(path + sr.Name);
            node.SelectedIndex := node.ImageIndex;
            node.HasChildren := false;

            if FindFirst(path + sr.name + '\*.*', faDirectory, srChild) = 0
            then
            begin
                  repeat

                      if sr.Name = '.'  then Continue;
                      if sr.Name = '..' then Continue;

                      if srChild.Attr and faDirectory > 0
                      then  node.HasChildren := true;

                  until (FindNext(srChild) > 0) or node.HasChildren;
            end;

            FindClose(srChild);
        end;

    until FindNext(sr) > 0;

end

else ParentNode.HasChildren := false;

FindClose(sr);

end;




procedure TVE_OneIcoRefresh(TV: TTreeView; Node: TTreeNode; icoPath : string);
var
i: integer;
//NodeParent, NodeSelect: TTreeNode;
Icon1: TIcon;

begin     

Icon1 := TIcon.Create;

//Icon1.LoadFromFile(icoPath);
//Form1.LV.SmallImages.GetIcon(Form1.LV.Selected.ImageIndex, Icon1); //   LVE

//i := Form1.IL_TV.AddIcon(Icon1);

Node.ImageIndex    := i;
Node.SelectedIndex := i;
//ShowMessage(inttostr(i));

Icon1.Free;




////1    Desktop.ini
//if Fol_ico_GetFromDesctopIni(Nod_Path(Node), icoPath, icoIndex)
//then
//begin
//    yy(icoPath);
//    if Form1.IL_TV.FileLoad(rtIcon, icoPath, clDefault)
//    then
//    begin
//      yy('ico   IL');
//      Node.ImageIndex    := Form1.IL_TV.Count - 1;
//      Node.SelectedIndex := Form1.IL_TV.Count - 1;
//    end;
//
//    Form1.Image1.Picture.LoadFromFile(icoPath);
//end;





////2
//Icon1 := TIcon.Create;
//
// ,   
//  ind:=-1,     ,  
//  ExtractIcon. ..     
//ind := 1;
//Icon1.Handle := ExtractAssociatedIcon(hInstance, PAnsiChar(Form1.Edit1.Text), ind);
//Form1.Image1.Picture.Icon := Icon1;
//Icon1.Free;




////3
//s := TV.Selected.Text;
//NodeParent := TV.Selected.Parent;
//TVE_LoadSub(TV, TV.Selected.Parent);
//i := IL_TV.AddIcon(Icon1);
//TV.Selected.ImageIndex := i;
//
//Icon1.Free;

//NodeSelect := NodeParent.getFirstChild;
//while True
//do
//begin
//    if NodeSelect = nil then Break;
//    if NodeSelect.Text = s
//    then
//    begin
//      NodeSelect.Selected := True;
//      NodeParent.Expand(False);
//      Break;
//    end;
//    NodeSelect := Node.getNextSibling;
//
//end;





end;




function TVE_DownTo(TV: TTreeView; Path: string; Separator: Char): TTreeNode;
//     Path    
var
  List: TStringList;
  Node: TTreeNode;
  i: integer;
  s: string;

begin

Result := nil;

if TV = nil then exit;
if TV.Items.Count = 0 then exit;
if Path = '' then exit;
if Separator = '' then exit;

//ShowMessage('!');

List := TStringList.Create;

//     
s := StringReplace(Path, Separator, #13#10,[rfReplaceAll]);

//  
List.Text := s;

//    
Node := TV.Items[0];


//     
for i := 0 to List.Count - 1
do
begin


    //      
    while (Node <> nil) and (Node.Text <> List[i])
    do Node := Node.getNextSibling;

//    ShowMessage(List[i] +#13#10+ Node.Text);

    //   
    if Node = nil then Break;
    if i = List.Count - 1 then Break; //     
    

    TVE_LoadSub(TV, Node);

    Node.Expand(False);

    //    
    if i < List.Count - 1 then Node := Node.getFirstChild;
end;

TV.Selected := Node;
List.Free;
Result := Node;

end;




{$ENDREGION}





end.
